Subject: RE: Prune AssertWinner

From: vishwas <[email-masked]>
Date: Sat, 14 Nov 98 20:27:00 PST

> Hi all,
>  In section 5.5, under "Assert received on outgoing interface: " it is   

> mentioned that,
>
> 1) .... If the value in the Assert is less than ur value, prune the
> interface.
>
> JUST PRUNING THE INTERFACE WONT SERVE THE PURPOSE, in case of following   

> topology, WHERE in, assert looser R3 has to send a prune to assert   
winner
> R1. Else R1 will contine to flood.

no... in PIM-DM (the latest spec) the assert winner schedules a prune of
its interface (the assert winner) until/unless it gets a join... and so
the scenario that you pointed to will not happen.

[actually I ran into this specific bug for an earlier version and then it   

was fixed in the versions thereafter],

[vishwas]
 ---------------------------------------------------------------------
It is not mentioned in the draft that assert Winner will schedule a   
prune. Thats where the problem comes from. It is only mentioned that   
assert Looser has to "prune the interface",
which wont serve the purpose. So assert Looser has to send prune for the   
assert Winner for that (S,G).
Pl. Go through the section "Asserts received on outgoing interface:" and   
confirm with me.

Hay Bill Did U check this out..?
 --------------------------------------------------------------------------  
 ----

>
>                                 O
>                   ________ |____________
>                       |                   |
>                 R1 O                  O R2
>                       |               __ |______
>                     P2P                      |
>                       |______________O R3
>                                           ___ |_______
>                                                       |
>                                                      O
> Explanation :
>         R1 is down initially, so R2 is upstream for R3, later when R1   

> comes up, it floods data on P2P link, which happens to be R3 outgoing   

> interface list, so R3 will send an assert, and R1 will respond back, R1   

> wins, R3 Prunes the P2P INTERFACE (As per draft), But unless R3 sends a   

> Prune to Assert winner, R1 in this case he will continue to flood as he   

> hasent got any prune from downstream (Flood and Prune Funda).
>
> Note : Just pruning the interface would have worked out fine, if we
> replace P2P link by ETHERNET. But to generalise, it SHOULD be mentioned   

> in the draft that, Assert Looser should prune the interface and SHOULD   

> also send the prune to the Assert Winner (Assert Winner will schedule a   

> prune and take appropriate actions by prune overrides and all....)
>
>  -vishu
> Regards
> Vishwanath S. Edavayyanamath
>   
 -------------------------------------------------------------------------  
 -
>  ------------------------
> Software Engineer, Future Software Pvt. Ltd, Chennai, India
> Ph : +91-44-4330550 (335)
> Private e-mail : [email-masked]
>

---

From: Ahmed A-G Helmy <[email-masked]>
Date: Sat, 14 Nov 1998 16:14:53 -0800 (PST)

> [vishwas]

Hi Vishwas,

	here is the excerpt from the latest spec I have [dated May 97] in 
	section 5.5 [parallel paths to the source]:

        "3 If you have won the election but there are no directly
             connected members on the LAN, schedule to prune the
             interface. The LAN might be a stub LAN with no members (and
             no downstream routers).  If no subsequent Joins are
             received, delete the interface from the outgoing interface
	..."

	I know it is there cuz I have run into this bug earlier (I have 
	used a method I am working on for authomatic test generation, 
	and published the results in a paper, and this bug was one of 
	the results discovered, it is on my web page)

Regards,
-Ahmed

---

From: Bill Fenner <[email-masked]>
Date: Mon, 16 Nov 1998 09:18:03 PST

In message <[email-masked]>you write:
>prune. ...
>Go through the section "Asserts received on outgoing interface:"

Ok.

How about #3?  "schedule to prune the interface" ... "If  no
      subsequent  Joins  are  received,  delete  the  interface from the
      outgoing interface list."

  Bill